package com.rational.rpw.compositetreeview;

import javax.swing.tree.MutableTreeNode;

/**
 * This interface specifies the operations that can be called
 * when something has changed in the tree.
 */
public interface TreeChangeListener
{
    /**
     * Called by the user when the node has changed, the node is
     * repainted.
     * @param   changedNode     The node which has changed.
     */
    public void nodeChanged( MutableTreeNode changedNode );
    
    /**
     * Called by the user when the node structure has changed, 
     * the node is reloaded and repainted.
     * @param   changedNode     The node which has changed.
     */
    public void nodeStructureChanged( MutableTreeNode changedNode );    
    
    /**
     * Called by the user when the selection has changed.
     * @param   nodeToSelect    The node to select.
     */
    public void nodeSelectionChanged( MutableTreeNode nodeToSelect );    
}