package com.rational.rpw.compositetreeview;

import java.awt.dnd.DnDConstants;
import javax.swing.JTree;


/**
 * This class acts as a link source, where drag operations does
 * not remove the nodes from its component.  
 */
public class TreeDragAsLinkComponent extends TreeDragComponent
{
    /**
     * Constructor.
     * @param   tree        The container tree.
     * @see java.awt.dnd.DnDConstants
     */
    public TreeDragAsLinkComponent( JTree tree )
    {
        // strategy is to use MOVE because that is the default
        // Java provide gesture.  The move() operation is 
        // overridden below to not do the actual remove from source.
        super( DnDConstants.ACTION_MOVE,
               tree );
    }

    /**
     * Override to actually not do the removal of the node from source.
     */
    public void move()
    {
        // do nothing
    }
    
}