package com.rational.rpw.dnd;

import java.awt.dnd.*;
import java.awt.datatransfer.*;

/**
 * This interface can be implemented to be able to act as
 * used with a DropTargetAdapter.
 */
public interface IDropComponent 
{
    /**
     * Called by the DropTargetAdapter in dragEnter, dragOver and
     * dragActionChanged 
     */
    public void dragUnderFeedback( boolean ok, 
                                   DropTargetDragEvent dropTargetDragEvent );

    /**
     * Called by the DropTargetAdapter in dragEnter, dragOver and
     * dragActionChanged 
     */
    public boolean isDragOk( DropTargetDragEvent dropTargetDragEvent );

    /**
     * Called by the DropTargetAdapter in dragExit and drop
     */
    public void undoDragUnderFeedback();

    /**
     * Called by the DropTargetAdapter in drop
     * @return  boolean     <code>true</code> if successful, <code>false</code> if not
     */
    public boolean add( Object objectToDrop, 
                        DropTargetDropEvent dropTargetDropEvent, 
                        DataFlavor dataFlavor );
}
