package com.rational.rpw.dnd;

import java.awt.datatransfer.Transferable;

/**
 * This class stores a static copy of the current transferable object.
 * It allows drag sources to set the transferable, and receivers to
 * retrieve it.
 */
public class TransferableStore
{
    private static Transferable _transferableObject = null;

    /**
     * Private constructor.
     */
    private TransferableStore()
    {
    }

    /**
     * Sets the transferable object.
     */
    public static void setTransferableObject( Transferable transferableObject )
    {
        _transferableObject = transferableObject;
    }

    /**
     * Retrieves the transferable object.
     */
    public static Transferable getTransferableObject()
    {
        return( _transferableObject );
    }
}