package com.rational.rpw.dnd.datatransfer;

/**
 * Copyright 2002 Rational Software Corporation. All Rights Reserved.
 * This software contains proprietary and confidential information of
 * Rational and its suppliers. Use, disclosure or reproduction is
 * prohibited without the prior express written consent of Rational.
 */

/**
 * This class provides an augmented view of a file within the content 
 * library. It records not only all the normal file operations that 
 * we have but also records which models content library it came from.
 * 
 * This information is neccessary to be maintained so that when we are
 * publishing we can figure out the full path to the file.
 */

import java.io.File;

public class ProcessFile
{
	private File _theFile;
	private String _processModelName;
	
	public ProcessFile(File theFile, String processModelName)
	{
		_theFile = theFile;
		_processModelName = processModelName;		
	}
	
	
	public File getFile()
	{
		return _theFile;
	}
	
	public String getModelName()
	{
		return _processModelName;
	}
}

