package com.rational.rpw.processtools;

import java.util.Vector;
import java.util.Enumeration;
import java.io.Serializable;

/**
 * This class contains the default extended help site and a site list. <br>
 *
 * Copyright 2001 - 2002 Rational Software Corporation. All Rights Reserved.
 * This software contains proprietary and confidential information of
 * Rational and its suppliers. Use, disclosure or reproduction is
 * prohibited without the prior express written consent of Rational.
 */
public class ContextSiteRegistry implements Serializable
{
	static final long serialVersionUID = -8146139637172953545L;
	
	// default site
	public String _defaultSite = null;
	
	// site list
	public Vector _siteList = null;
	
	/**
	 * Default constructor.
	 */
	public ContextSiteRegistry()
	{
		_siteList = new Vector();
	}

	public void setDefaultSite( String defaultSite )
	{
		_defaultSite = defaultSite;
	}
	
	public String getDefaultSite()
	{
		return( _defaultSite );
	}
	
	public void addSite( String site )
	{
		if( !_siteList.contains( site ) )
		{
			_siteList.addElement( site );
		}
		// if this is the only site, just set it to the default
		if( _siteList.size() == 1 )
		{
			setDefaultSite( site );
		}
	}
	
	public Enumeration getSites()
	{
		return( _siteList.elements() );
	}
	
	public Vector getSiteList()
	{
		return( _siteList );
	}
	
	public void removeSite( String site )
	{
		if( _siteList.contains( site ) )
		{
			_siteList.removeElement( site );
		}
		// if this is default, reset default to first one in the list
		if( site.equals( _defaultSite ) && _siteList.size() > 0 )
		{
			setDefaultSite( (String)_siteList.elementAt( 0 ) );
		}
	}
		
}

