package com.rational.rpw.processtools;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;

import com.rational.rpw.processview.IconManager;
import com.rational.rpw.processviewer.DocumentBase;
import com.rational.rpw.processviewer.IViewerActionListener;
import com.rational.rpw.processviewer.ViewerMainIconMenu;
import com.rational.rpw.processviewer.ViewerUtilities;

/**
 * This class provides the main menu icon strip for view actions. 
 * Actions here include save, save as, add new node, etc. <br>
 *
 * Copyright 2001 - 2002 Rational Software Corporation. All Rights Reserved.
 * This software contains proprietary and confidential information of
 * Rational and its suppliers. Use, disclosure or reproduction is
 * prohibited without the prior express written consent of Rational.
 */
public class RupPresenterIconMenu extends ViewerMainIconMenu
	implements ActionListener
{
	protected JButton _addFromDefaultButton = null;
		
	/**
	 * Constructor.
	 */
	public RupPresenterIconMenu( IViewerActionListener listener )
	{
		super( listener );
	}
		
	/**
	 * Construct icon menu panel
	 */
	public JPanel getMenuPanel()
	{
		if( null == _buttonPanel )
		{
			super.getMenuPanel();
		
			String documentBase = DocumentBase.getDocumentBase().toString();
			int index = documentBase.lastIndexOf( ViewerUtilities.UNC_SEPARATOR );
			if( -1 == index )
			{
				index = documentBase.lastIndexOf( File.separator );
			}
			String finalDocumentBase = null;
			if( -1 != index )
			{
				finalDocumentBase = documentBase.substring( 0,index );				
			}
			else
			{
				finalDocumentBase = documentBase;
			}
			String base = ViewerUtilities.convertFilename( finalDocumentBase + 
	 		   	                                           ViewerUtilities.UNC_SEPARATOR +
	   		 	                                           "images" + //$NON-NLS-1$
	    		                                           ViewerUtilities.UNC_SEPARATOR );
			IconManager iconManager = new IconManager();
			ImageIcon addFromDefaultIcon = iconManager.getIcon( base + "action_add.gif" ); //$NON-NLS-1$

			// insets and background
			java.awt.Insets insets = new java.awt.Insets( 0, 0, 0, 0 );
			Color background = new Color( 239, 239, 239 );
    		
			_addFromDefaultButton = new JButton( addFromDefaultIcon );
			_addFromDefaultButton.setToolTipText( Translations.getString("PROCESSTOOLS_82") );  //$NON-NLS-1$
			_addFromDefaultButton.setMargin( insets );	 
			_addFromDefaultButton.setBackground( background );			
			_addFromDefaultButton.setBorder( BorderFactory.createLineBorder( Color.white ) );			
			_addFromDefaultButton.addActionListener( this );
			_buttonPanel.add( _addFromDefaultButton );
		}		
			
		return( _buttonPanel );
	}
		
	/**
	 * Action listener.
	 */
	public void actionPerformed( ActionEvent e )
	{
		if( e.getSource() == _addFromDefaultButton )
		{
			_actionListener.handleAction( IViewerActionListener.ACTION_ADD_FROM_DEFAULT );
		}
		else
		{
			super.actionPerformed( e );
		}
	}
}

