package com.rational.rpw.processtools;
import java.awt.Component;
import java.awt.Color;
import java.awt.Font;
import javax.swing.JTree;
import javax.swing.JLabel;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultMutableTreeNode;

import com.rational.rpw.processview.Bookmark;
import com.rational.rpw.processview.IconManager;
import com.rational.rpw.processviewer.ViewerTreeCellRenderer;

/**
 * This class renders tree cells for the Rup tree browser. <br>
 *
 * Copyright 2001 - 2002 Rational Software Corporation. All Rights Reserved.
 * This software contains proprietary and confidential information of
 * Rational and its suppliers. Use, disclosure or reproduction is
 * prohibited without the prior express written consent of Rational.
 */
public class RupPresenterTreeCellRenderer extends ViewerTreeCellRenderer
{
	public RupPresenterTreeCellRenderer( IconManager iconManager )
	{
		super( iconManager );	
	}
	
    /**
     * Sets the current tree cell to value.
     */
    public Component getTreeCellRendererComponent( JTree tree,
                                                   Object value,
                                                   boolean sel,
                                                   boolean expanded,
                                                   boolean leaf,
                                                   int row,
                                                   boolean hasFocus)
    {
        // set all the defaults first        
        super.getTreeCellRendererComponent( tree,
                                            value,
                                            sel,
                                            expanded,
                                            leaf,
                                            row,
                                            hasFocus );

	    this.setTextNonSelectionColor( new Color( 51,102,153 ) );			
        this.setTextSelectionColor( Color.white );
        this.setBackgroundNonSelectionColor( this.getBackground() );
        this.setBackgroundSelectionColor( new Color( 51,102,153 ) );
        this.setBorderSelectionColor( this.getBackground() );

		/*if( ((Bookmark)value).isMouseOver() && !sel )
		{
			// special case used for mouse-over					
        	this.setForeground( new Color( 0,0,102 ) );
		}
		else
		{
			if( sel )
			{
	        	this.setForeground( this.getTextSelectionColor() );
			}
			else
			{
	        	this.setForeground( this.getTextNonSelectionColor() );
			}
		}*/
		
		if( !((Bookmark)value).isExist() )
		{
			// special case used for when the bookmark doesn't exist
			Font defaultFont = this.getFont();
        	this.setFont( new Font( defaultFont.getName(),
        	                        Font.ITALIC,
        	                        defaultFont.getSize() ) );
		}
		
        return this;
    }
    
}