package com.rational.rpw.processtools;

import java.net.URL;

import com.rational.rpw.filelibrary.PathMap;

/**
 * This class provides a URL path map. <br>
 *
 * Copyright 2001 - 2002 Rational Software Corporation. All Rights Reserved.
 * This software contains proprietary and confidential information of
 * Rational and its suppliers. Use, disclosure or reproduction is
 * prohibited without the prior express written consent of Rational.
 */

public class UrlPathMap extends PathMap
{
	protected URL _baseUrl = null;
	
	/**
	 * Constructor that takes in a URL.
	 */
	public UrlPathMap( URL baseUrl ) 
	{
		super();
		_baseUrl = baseUrl;
	}
	
	/**
	 * Overrides getLibraryPath() to return the base url,
	 * regardless of the model name.
	 */
	public String getLibraryPath(String modelName)
	{
		return( _baseUrl.toString() );		
	}

}

