package com.rational.rpw.processview;

/**
 * This class keeps track of whether the visiblity filter should be
 * applied towards bookmark nodes. <br>
 *
 * Copyright 2001 - 2002 Rational Software Corporation. All Rights Reserved.
 * This software contains proprietary and confidential information of
 * Rational and its suppliers. Use, disclosure or reproduction is
 * prohibited without the prior express written consent of Rational.
 */
public class BookmarkVisibilityFilter
{
	// whether to apply visiblity filter; takes into account
	// hidden/unhidden, enabled/disabled, and
	// transparent/nontransparent states
	public static boolean _isApplyVisiblityFilter = false;
	
	// whether to show actual only, regardless of visibility
	public static boolean _isActualOnly = false;
	
	public static void applyVisiblityFilter()
	{
		_isApplyVisiblityFilter = true;
	}
	
	public static void removeVisiblityFilter()
	{
		_isApplyVisiblityFilter = false;
	}
	
	public static boolean isApplyVisibilityFilter()
	{
		return( _isApplyVisiblityFilter );
	}

	public static void applyActualOnly()
	{
		_isActualOnly = true;
	}
	
	public static void removeActualOnly()
	{
		_isActualOnly = false;
	}
	
	public static boolean isActualOnly()
	{
		return( _isActualOnly );
	}

}
