package com.rational.rpw.processviewer;

/**
 * This interface allows menu items, buttons, etc. to get user
 * input independent of the process viewer. The application that
 * implements this listener then knows how to handle the various
 * actions depending on the application's context. <br>
 *
 * Copyright 2001 - 2002 Rational Software Corporation. All Rights Reserved.
 * This software contains proprietary and confidential information of
 * Rational and its suppliers. Use, disclosure or reproduction is
 * prohibited without the prior express written consent of Rational.
 */
public interface IViewerActionListener
{
	// actions that can be done
	public static final int ACTION_NEW_VIEW = 1000;
	public static final int ACTION_SAVE_VIEW = 1001;
	public static final int ACTION_SAVE_VIEW_AS = 1002;
	public static final int ACTION_DELETE_VIEW = 1003;
	public static final int ACTION_ADD_NEW_NODE = 1004;
	public static final int ACTION_ADD_FROM_DEFAULT = 1005;
	public static final int ACTION_SYNCHRONIZE_VIEW = 1006;
	public static final int ACTION_SHOW_ALL_VIEWS = 1007;
	public static final int ACTION_SHOW_SINGLE_VIEW = 1008;
	public static final int ACTION_SELECT_NODE = 1009;
	public static final int ACTION_SHOW_INVISIBLE_ELEMENTS = 1010;
	public static final int ACTION_HIDE_INVISIBLE_ELEMENTS = 1011;
	
	
	/**
	 * Handles action that the user has requested.
	 * @param actionType	One of the action types in this interface.
	 */
	public void handleAction( int actionType );
	
	/**
	 * Handles action that the user has requested.
	 * @param actionType	One of the action types in this interface.
	 * @param objectForAction	An object that is required for the action.
	 */
	public void handleAction( int actionType,
	                          Object objectForAction );
}

