package com.rational.rpw.processviewer;

import javax.swing.event.TreeModelListener;
import javax.swing.event.TreeModelEvent;
import com.rational.rpw.processview.*;


/**
 * This class listens for changes to the tree model and saves the
 * associated bookmark. <br>
 * 
 * Copyright 2001 - 2002 Rational Software Corporation. All Rights Reserved.
 * This software contains proprietary and confidential information of
 * Rational and its suppliers. Use, disclosure or reproduction is
 * prohibited without the prior express written consent of Rational.
 */
public class ViewerTreeModelListener 
	implements TreeModelListener
{
	protected ViewerTabPanel _tabPanel = null;
	protected String _applicationDirectory = null;
	
	/**
	 * Default constructor.
	 */	
	public ViewerTreeModelListener( ViewerTabPanel tabPanel,
	                                String applicationDirectory )
	{
		_tabPanel = tabPanel;
		_applicationDirectory = applicationDirectory;
	}
	
    public void treeNodesChanged(TreeModelEvent e) 
    {
    	saveBookmark();
    }
    public void treeNodesInserted(TreeModelEvent e) 
    {
    	saveBookmark();
    }
    public void treeNodesRemoved(TreeModelEvent e) 
    {
    	saveBookmark();
    }
    public void treeStructureChanged(TreeModelEvent e) 
    {
    	saveBookmark();
    }
    
    protected void saveBookmark()
    {
    	try
     	{
     		Bookmark bookmark = _tabPanel.getBookmarkForSelectedView();
       		BookmarkLibrary.writeBookmark( bookmark,
                                   		   bookmark.getFileName(),
                                           _applicationDirectory );
		}
		catch( Exception ex )
		{
			ex.printStackTrace();			
		}		    	
    }
    
}

