package com.rational.rpw.search;

import org.apache.lucene.analysis.cn.ChineseAnalyzer;
import org.apache.lucene.queryParser.ParseException;
import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.search.Hits;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.Searcher;

/**
 * Copyright 2001 - 2002 Rational Software Corporation. All Rights Reserved.
 * This software contains proprietary and confidential information of
 * Rational and its suppliers. Use, disclosure or reproduction is
 * prohibited without the prior express written consent of Rational.
 */
public class SearchRup 
{

	public static final String CONTENTS = "contents";

	public static void main(String[] args) 
	{
		if (args.length > 0)
		{
//			String rupPath = System.getProperty( "user.home" ) + java.io.File.separator + "rup";
			String rupPath = args[0];
			Hits hits = SearchRup.searchIndex(rupPath + "\\index", "Analyst", CONTENTS);
			System.out.println("There are " + hits.length() + " hits for 'analyst'");
		}
	}
	
	public static Hits searchIndex( String indexFullPath, 
	                                 String searchString, 
	                                 String field)
	{
		Hits result = null;
		try
		{
			String stopWordPath = indexFullPath;//.substring(0, indexFullPath.lastIndexOf(File.separator));
			String[] stopwords = StopWordReader.getStopwords( 
				stopWordPath,
                Indexer.STOPWORDS_FILE );
			//StopAnalyzer analyzer = new StopAnalyzer(stopwords);
			
			// the chinese analyzer here will work with japanese, korean as well as
			// latin based languages such as English
			ChineseAnalyzer analyzer = new ChineseAnalyzer( stopwords );
			Query query = QueryParser.parse(searchString, field, analyzer);
			Searcher searcher = new IndexSearcher(indexFullPath);
			result = searcher.search(query);
		}
		catch (ParseException p1)
		{
			p1.printStackTrace();
		}
		catch (java.io.IOException i1)
		{
			i1.printStackTrace();
		}

		// TO DEBUG
//		try
//		{
//			for (int i=0; i<10; i++)
//			{
//				org.apache.lucene.document.Document doc = result.doc(i);
//				org.apache.lucene.document.Field url = doc.getField("url");
//				org.apache.lucene.document.Field title = doc.getField("title");
//				org.apache.lucene.document.Field summary = doc.getField("summary");
//				String test = url.stringValue();
//				javax.swing.JOptionPane.showMessageDialog(null, url.stringValue());
//				javax.swing.JOptionPane.showMessageDialog(null, summary.stringValue());
//				
//			}
//		}
//		catch (java.io.IOException e1) {}

		return result;
	}
}

