package com.rational.rpw.search.indexutil;

import java.awt.Dimension;
import java.awt.event.MouseEvent;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.net.URL;
import java.util.StringTokenizer;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import javax.swing.AbstractButton;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.plaf.basic.BasicButtonListener;

import com.rational.rpw.processviewer.ViewerUtilities;

public class IndexLoader extends JFrame 
{
	public static final String VERSION_FILE_NAME = "version.txt";
	public static final String VERSION_DELIMITER = "*";
	public static final String DOWNLOAD_ERROR = "Unable to download index.jar file";
	protected String m_docBase;
	protected String m_indexFolder;
	protected String m_indexFile;
//	protected JFrame m_frame;
	protected JButton closeButton;
	protected String indexArchive;
	protected JTextArea display;
	protected JLabel labeler;
	protected JProgressBar progress;
	protected long tally;
	protected int fileSize;

	public String go()
	{
		byte bytes[] = new byte[16384];

//		JDialog hello = new JDialog(m_frame);
		setSize(new Dimension (450, 300));
		//progress = new JProgressBar(JProgressBar.HORIZONTAL, 0, 100);
		BoxLayout tBox = new BoxLayout(getContentPane(), BoxLayout.Y_AXIS);
		getContentPane().setLayout(tBox);
//		hello.getContentPane().setLayout(new BoxLayout(hello, BoxLayout.Y_AXIS));
		labeler = new JLabel("First we well download the index file to the local machine");
		display = new JTextArea();
		display.setEditable(false);
		JScrollPane results = new JScrollPane(display);
		JPanel bottom = new JPanel();
		BoxLayout bBox = new BoxLayout(bottom, BoxLayout.X_AXIS);
		bottom.setLayout(bBox);
		//bottom.add(progress);
		closeButton = new JButton("Close");
		closeButton.setEnabled(false);
		bottom.add(closeButton);
		CloseButtonListener blisten = new CloseButtonListener(closeButton);
		closeButton.addMouseListener(blisten);
		getContentPane().add(results);
		getContentPane().add(labeler);
		getContentPane().add(bottom);
		invalidate();
		validate();
		show();

		String product = "";
		File versionFile = null;
		
		try
		{
			toFront();
			// TBD replace 100 with something to do with archive size or something
			String base = m_docBase;
			base = base.substring(0, base.lastIndexOf("/"));
			base = base + "/search/index/index.jar";

			URL url = new URL(base);
			// handle UNC
			url = ViewerUtilities.handleURLForUNC( url );

			File folder = new File(m_indexFolder);
			folder = folder.getParentFile();

			if (folder.exists())
			{
				folder.delete();
			}
			
			File indexArchive = new File(m_indexFile);
			indexArchive.getParentFile().mkdirs();

			// let's get the attrbutes of the file we want to download.
			versionFile = new File(m_indexFolder + File.separator + VERSION_FILE_NAME);
			FileReader readVersion = new FileReader(versionFile);
			BufferedReader bRead = new BufferedReader(readVersion);
			String versionString = bRead.readLine();
			bRead.close();
			readVersion.close();
			StringTokenizer tok = new StringTokenizer(versionString, VERSION_DELIMITER);
			product = tok.nextToken();
			String date = tok.nextToken();
			fileSize = Integer.parseInt(tok.nextToken());

			BufferedInputStream inputS = new BufferedInputStream( url.openStream());
			FileOutputStream writeArchive = new FileOutputStream(indexArchive);
			display.setText(
				"The search requires some files to be downloaded and installed on\n"
				+ "your machine. This process is only required the first time you\n"
				+ "run search on an installed version of RUP.\n\n"
				+ "It will automatically run again if you load a different version\n" 
				+ "of RUP or the search index is regenerated by the RUP administrator.\n\n"
				+ "Creating: " + m_indexFile);
			labeler.setText("Downloading index...");
			//progress.setValue(0);
				
			String what = display.getText();
			what = what + ("\n\nSaving the jar file");
			display.setText(what);

			tally = 0;
			int streamNotAvailable = 0;
	
			while (tally<fileSize)
			{
				if (inputS.available() > 0)
				{
					streamNotAvailable = 0;
					int num = inputS.read(bytes);
					writeArchive.write(bytes, 0, num);
					tally = tally + num;
					//progress.setValue((int)(tally*100/fileSize));
				}
				else
				{
					try
					{
						wait(50);
						if (streamNotAvailable > 100)
						{
							throw new Exception(DOWNLOAD_ERROR);
						}
						streamNotAvailable ++;
					}
					catch (Exception e1){}
				}
			}

			inputS.close();
			writeArchive.close();

			//progress.setValue(0);
			tally = 0;
			String newIndexFolderName = m_indexFolder;
			
			labeler.setText("Extracting index to local hard drive...");

			what = display.getText() + "\n\nExtracting index files:\n";
			display.setText(what);
			
			ZipInputStream zStream = new ZipInputStream(new FileInputStream(m_indexFile));
			ZipEntry zEntry = zStream.getNextEntry();
			while (zEntry != null)
			{
				what = display.getText() + "\nWriting file: " + newIndexFolderName + zEntry.getName();
				display.setText(what);
				File file = new File(newIndexFolderName, zEntry.getName());
				
				if (zEntry.isDirectory())
				{
					file.mkdir();
				}
				else
				{
					file.getParentFile().mkdirs();
					FileOutputStream outs = new FileOutputStream(file);
					while (zStream.available() > 0)
					{
						int num = zStream.read(bytes);
						if (num > 0)
						{
							outs.write(bytes, 0, num);
						}
					}
					outs.close();
					tally++;
					//progress.setValue((int)tally * 8);
				}
				
				zEntry = zStream.getNextEntry();
			}
			zStream.close();

			what = display.getText() + "\n\nCompleted writing the index files successfully";
			labeler.setText("Done. Search enabled.");
			//progress.setValue(100);
		}
		catch (Exception e1) 
		{
			String message = e1.getMessage();
			String displ = display.getText();
			displ = displ + "\n\n"
				+ "There was an error extracting the index on your machine\n"
				+ "Search will be disabled.  Please close the search window\n"
				+ "and launch it again.  Possible problems include a bad network\n"
				+ "connection, or perhaps a corrupt index on the server.";
			display.setText(displ);
			System.out.println(message);
			product = null;
			versionFile.delete();
			
			e1.printStackTrace();
		}
		finally
		{
			closeButton.setEnabled(true);
//			dispose();
		}
		return product;
	}
	/**
	 * Constructor for IndexLoader
	 */
	public IndexLoader(String documentBase, String indexFolder, String indexFile) 
	{
//		super(par);
		m_docBase = documentBase;
		m_indexFolder = indexFolder;
		m_indexFile = indexFile;
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		//		m_frame = (JFrame) frame;
		setTitle("Downloading index to machine to enable search");
	}
	
	public class CloseButtonListener extends BasicButtonListener
	{
		public CloseButtonListener(AbstractButton b)
		{
			super(b);
		}
		
		// made change to run the code on mouseReleased because it wasn't
		// always catching 'clicked' events.
		public void mouseReleased(MouseEvent e)
		{
			if (e.getModifiers() == MouseEvent.BUTTON1_MASK)
			{
				if (closeButton.isEnabled())
				{
					dispose();
				}
			}
		}
	}
}

