package org.apache.lucene.analysis.cn;

import java.io.Reader;
import java.util.Hashtable;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.StopFilter;
import org.apache.lucene.analysis.TokenStream;

/**
 * Title: ChineseAnalyzer
 * Description:
 *   Subclass of org.apache.lucene.analysis.Analyzer
 *   build from a ChineseTokenizer, filtered with ChineseFilter.
 * Copyright:   Copyright (c) 2001
 * Company:
 * @author Yiyi Sun
 * @version 1.0
 *
 */
/**
 * Modified by fchong@rational.com on December 9, 2002, for Rational
 * use.
 * 
 * Copyright 2001 - 2002 Rational Software Corporation. All Rights Reserved.
 * This software contains proprietary and confidential information of
 * Rational and its suppliers. Use, disclosure or reproduction is
 * prohibited without the prior express written consent of Rational.
 */
public class ChineseAnalyzer extends Analyzer 
{

  	/*
   	 * Stop words
   	 */
  	private static Hashtable _stopTable = null;

	/**
	 * Default constructor.
	 */
	public ChineseAnalyzer( String[] stopWords )
	{
		_stopTable = StopFilter.makeStopTable( stopWords );			
	}
	
    /**
    * Creates a TokenStream which tokenizes all the text in the provided Reader.
    *
    * @return  A TokenStream build from a ChineseTokenizer filtered with ChineseFilter.
    */
    public final TokenStream tokenStream(String fieldName, Reader reader) {
        TokenStream result = new ChineseTokenizer(reader);
        result = new ChineseFilter(_stopTable, result);
        return result;
    }
}